#pragma once

#include "Arduino/Things/UltrasonicSensor.h"
#include "Arduino/Things/DRV8833.h"
#include "Arduino/Things/DigitalInput.h"

using namespace RoboidControl::Arduino;

#if defined(ESP32)
static constexpr DRV8833::Configuration driveConfig = {
    17,  // AIn1
    16,  // AIn2
    14,  // BIn1
    27   // BIn2
};
static constexpr UltrasonicSensor::Configuration leftTouchConfig = {
    25,  // Trigger
    33   // Echo
};
static constexpr UltrasonicSensor::Configuration rightTouchConfig = {
    15,  // Trigger
    5    // Echo
};

#elif defined(UNO) || defined(UNO_R4)
static constexpr DRV8833::Configuration driveConfig = {
    5,  // AIn1
    6,  // AIn2
    7,  // BIn1
    10  // BIn2
};

static constexpr UltrasonicSensor::Configuration leftTouchConfig = {
    A0,  // Trigger
    12   // Echo
};
static constexpr UltrasonicSensor::Configuration rightTouchConfig = {
    A1,  // Trigger
    11   // Echo
};

static constexpr DigitalInput::RelativeEncoder::Configuration
    leftEncoderConfig = {
        2,  // Input pin
        80  // Pulses per revolution
};
static constexpr DigitalInput::RelativeEncoder::Configuration
    rightEncoderConfig = {
        3,  // Input pin
        80  // Pulses per revolution
};
#endif